Imports System.Drawing
Imports System.Drawing.Drawing2D
Imports System.Drawing.Text
Imports System.ComponentModel
Imports System.Windows.Forms
Imports System.Windows.Forms.Design

<ToolboxBitmap(GetType(System.Windows.Forms.Button)), _
 Designer(GetType(MenuButton.MenuButtonDesigner))> _
Public Class MenuButton
    Inherits System.Windows.Forms.Button

#Region " R|[lg fUCiŐꂽR[h "

    Public Sub New()
        MyBase.New()

        ' ̌ĂяóAR|[lg fUCiŕKvłB
        InitializeComponent()

        ' {^ʏ̏Ԃŏ
        Me.btnState = ButtonState.Normal

        ' {^̗̈
        Me.Region = New Region(GetButtonRegionPath(0, 0))

    End Sub

    'Control ́AR|[lgꗗɌ㏈s邽߂ɁAdispose I[o[Ch܂B
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Rg[ fUCiŕKvłB
    Private components As System.ComponentModel.IContainer

    '  : ȉ̃vV[W̓R|[lg fUCiŕKvłB
    ' R|[lg fUCigĕύXł܂B
    ' R[h GfB^gĕύXȂłB  
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        components = New System.ComponentModel.Container
    End Sub

#End Region

#Region "{^̏ԊǗ"
    Public Enum ButtonState
        Normal  ' ʏ̏
        Hover   ' }EX{^̏ɂ
        Pressed ' }EXŉĂ
    End Enum

    Private btnState As ButtonState     ' {^̏Ԃێ

    ' {^̏̃}EXꂽƂɌĂяoB
    Protected Overrides Sub OnMouseLeave(ByVal e As EventArgs)
        MyBase.OnMouseLeave(e)
        Me.btnState = ButtonState.Normal
        Me.Invalidate()
    End Sub

    ' {^̏Ƀ}EXƂɌĂяoB
    Protected Overrides Sub OnMouseEnter(ByVal e As EventArgs)
        MyBase.OnMouseEnter(e)
        Me.btnState = ButtonState.Hover
        Me.Invalidate()
    End Sub

    ' {^}EXɂĉꂽƂɌĂяoB
    Protected Overrides Sub OnMouseDown(ByVal e As MouseEventArgs)
        MyBase.OnMouseDown(e)

        ' NbNꂽĕ`
        If e.Button = MouseButtons.Left Then
            Me.btnState = ButtonState.Pressed
            Me.Invalidate()
        End If

    End Sub

    ' {^̏}EXړƂɌĂяoB
    Protected Overrides Sub OnMouseMove(ByVal e As MouseEventArgs)
        MyBase.OnMouseMove(e)

        If Me.ClientRectangle.Contains(e.X, e.Y) Then
            If (Me.Capture = True) And (Me.btnState = ButtonState.Hover) Then
                ' Lv`ԁi}EXꂽ܂܁jŃ{^ԂHoverȂ
                ' ܂܃{^̊Oɖ߂ĂƂӖ
                Me.btnState = ButtonState.Pressed
                Me.Invalidate()
            End If
        Else
            If Me.btnState = ButtonState.Pressed Then
                ' {^ԂPressedrȂ
                ' ܂܃{^̓OɏoĂƂӖ
                Me.btnState = ButtonState.Hover
                Me.Invalidate()
            End If
        End If

    End Sub

    ' }EXɂNbNIƂɌĂяoB
    Protected Overrides Sub OnClick(ByVal e As EventArgs)
        If Me.ClientRectangle.Contains(Me.PointToClient(Control.MousePosition)) Then
            ' ʏ}EX{^ɂ͂
            Me.btnState = ButtonState.Hover
        Else
            ' }EX{^ɂȂꍇɂ͒ʏԂɂ
            Me.btnState = ButtonState.Normal
        End If
        Me.Invalidate()

        MyBase.OnClick(e)
    End Sub

    ' {^̗L^̏Ԃ؂ւƂɌĂяoB
    Protected Overrides Sub OnEnabledChanged(ByVal e As EventArgs)
        MyBase.OnEnabledChanged(e)

        ' {^̏Ԃ߂ĕ`
        Me.btnState = ButtonState.Normal
        Me.Invalidate()
    End Sub
#End Region

#Region "{^̗̈"
    ' {^̈̃pX擾
    Private Function GetButtonRegionPath(ByVal inflate As Integer, ByVal lineWidth As Integer) As GraphicsPath
        Dim rc As Rectangle = Me.ClientRectangle

        If inflate <> 0 Then
            rc.Inflate(inflate, inflate)
        End If
        If lineWidth <> 0 Then
            rc.Width = rc.Width - lineWidth
            rc.Height = rc.Height - lineWidth
        End If

        Dim sz As New Size(10, 10)

        Dim path As New GraphicsPath
        path.AddLine(rc.Left + CInt(sz.Width / 2), rc.Top, rc.Right - CInt(sz.Width / 2), rc.Top)
        path.AddArc(rc.Right - sz.Width, rc.Top, sz.Width, sz.Height, 270, 90)
        path.AddLine(rc.Right, rc.Top + CInt(sz.Height / 2), rc.Right, rc.Bottom - CInt(sz.Height / 2))
        path.AddArc(rc.Right - sz.Width, rc.Bottom - sz.Height, sz.Width, sz.Height, 0, 90)
        path.AddLine(rc.Right - CInt(sz.Width / 2), rc.Bottom, rc.Left + CInt(sz.Width / 2), rc.Bottom)
        path.AddArc(rc.Left, rc.Bottom - sz.Height, sz.Width, sz.Height, 90, 90)
        path.AddLine(rc.Left, rc.Bottom - CInt(sz.Height / 2), rc.Left, rc.Top + CInt(sz.Height / 2))
        path.AddArc(rc.Left, rc.Top, sz.Width, sz.Height, 180, 90)

        Return path
    End Function
#End Region

#Region "`揈"
    Protected Overrides Sub OnPaint(ByVal pe As System.Windows.Forms.PaintEventArgs)
        ' pl`悷
        DrawButton(pe.Graphics)

        ' {NXOnPaint͎sȂ
        'MyBase.OnPaint(pe)
    End Sub

    ' {^`悷B
    Private Sub DrawButton(ByVal g As Graphics)

        Select Case Me.btnState
            Case ButtonState.Normal ' ʏ̏
                If Me.Enabled = False Then
                    ' {^ȏ
                    DrawDisabledButton(g)
                ElseIf (Me.Focused) Then
                    ' {^ɃtH[JX
                    DrawFoucusedButton(g)
                Else
                    ' ʏ̏
                    DrawNormalButton(g)
                End If
            Case ButtonState.Hover    ' z[o[
                DrawHoverButton(g)

            Case ButtonState.Pressed  ' 
                DrawPressedButton(g)
        End Select

        ' eLXg`悷
        Me.DrawButtonText(g)
    End Sub

    ' ʏԂ̃{^`悵܂B
    Private Sub DrawNormalButton(ByVal g As Graphics)
        DrawButton(g, Me.BackColor, Color.White)
    End Sub

    ' Ԃ̃{^`悵܂B
    Private Sub DrawDisabledButton(ByVal g As Graphics)
        DrawButton(g, SystemColors.ControlDark, Color.White)
    End Sub

    ' tH[JXԂ̃{^`悵܂B
    Private Sub DrawFoucusedButton(ByVal g As Graphics)
        DrawButton(g, Color.Navy, Color.White)
    End Sub

    ' }EXɏĂԂ̃{^`悵܂B
    Private Sub DrawHoverButton(ByVal g As Graphics)
        DrawButton(g, Color.Navy, Color.Yellow)
    End Sub

    ' Ԃ̃{^`悵܂B
    Private Sub DrawPressedButton(ByVal g As Graphics)
        DrawButton(g, SystemColors.Highlight, Color.Black)
    End Sub

    ' {^`悷
    Private Sub DrawButton(ByVal g As Graphics, ByVal colorBack As Color, ByVal colorGradient As Color)
        Dim rectPaint As Rectangle = Me.ClientRectangle
        If (rectPaint.Width <= 0) Or (rectPaint.Height <= 0) Then
            Return ' `悵Ȃ
        End If
        Dim regionPaint As Region = Me.Region
        If regionPaint Is Nothing Then
            Return ' `悵Ȃ
        End If

        ' wiF{^Ŝɕ`
        Dim brushBack As SolidBrush = New SolidBrush(colorBack)
        g.FillRegion(brushBack, regionPaint)
        brushBack.Dispose()

        ' {^\ʂ̃OfG[V`
        Dim brushSurface As New LinearGradientBrush( _
         rectPaint, _
         Color.FromArgb(128, colorGradient), _
         Color.FromArgb(0, colorGradient), _
         LinearGradientMode.Vertical)
        Dim reginSurface As Region = New Region(GetButtonRegionPath(-1, 0))
        g.FillRegion(brushSurface, reginSurface)
        brushSurface.Dispose()
    End Sub

#End Region

#Region "{^eLXg̕`"
    ' {^̃eLXg`悷
    Private Sub DrawButtonText(ByVal g As Graphics)
        Dim rectPaint As RectangleF = RectangleF.op_Implicit(Me.ClientRectangle)
        If (rectPaint.Width <= 0) Or (rectPaint.Height <= 0) Then
            Return ' `悵Ȃ
        End If

        ' {^p̕tH[}bg擾
        Dim strFormat As StringFormat = GetButtonStringFormat()

        If Me.btnState = ButtonState.Pressed Then
            rectPaint.X += 1
            rectPaint.Y += 1
            Dim brushText As SolidBrush = New SolidBrush(Me.ForeColor)
            g.DrawString(Me.Text, Me.Font, CType(brushText, Brush), rectPaint, strFormat)


            brushText.Dispose()
        ElseIf Me.Enabled = True Then
            Dim brushText As SolidBrush = New SolidBrush(Me.ForeColor)
            g.DrawString(Me.Text, Me.Font, brushText, rectPaint, strFormat)
            brushText.Dispose()
        Else
            ' Rg[̖`悷ɂ
            ' Win32 APIDrawStateString֐gȂB
            ' ControlPaint.DrawStringDisabled\bh͂邪
            ' M҂A܂삵Ȃ悤B
            ' ȂAControlPaint.DrawImageDisabled͎g悤B

            ' ł́A1sNZEɂ炷ƂŁA^I3D\ۂ
            Dim brushLightText As SolidBrush = New SolidBrush(SystemColors.ControlLightLight)
            g.DrawString(Me.Text, Me.Font, brushLightText, rectPaint, strFormat)
            brushLightText.Dispose()
            rectPaint.X = rectPaint.X - 1
            rectPaint.Y = rectPaint.Y - 1
            Dim darkColor As Color
            If Me.Enabled Then
                darkColor = Me.ForeColor
            Else
                darkColor = SystemColors.ControlDark
            End If
            Dim brushDarkText As New SolidBrush(darkColor)
            g.DrawString(Me.Text, Me.Font, brushDarkText, rectPaint, strFormat)
            brushDarkText.Dispose()
        End If

        strFormat.Dispose()
    End Sub

    ' {^p̕tH[}bg擾B
    Private Function GetButtonStringFormat() As StringFormat
        Dim strFormat As StringFormat = New StringFormat()
        strFormat.HotkeyPrefix = System.Drawing.Text.HotkeyPrefix.Show
        Select Case Me.TextAlign
            Case ContentAlignment.MiddleCenter
                strFormat.LineAlignment = StringAlignment.Center
                strFormat.Alignment = StringAlignment.Center
            Case ContentAlignment.MiddleLeft
                strFormat.LineAlignment = StringAlignment.Center
                strFormat.Alignment = StringAlignment.Near
            Case ContentAlignment.MiddleRight
                strFormat.LineAlignment = StringAlignment.Center
                strFormat.Alignment = StringAlignment.Far
            Case ContentAlignment.TopCenter
                strFormat.LineAlignment = StringAlignment.Near
                strFormat.Alignment = StringAlignment.Center
            Case ContentAlignment.TopLeft
                strFormat.LineAlignment = StringAlignment.Near
                strFormat.Alignment = StringAlignment.Near
            Case ContentAlignment.TopRight
                strFormat.LineAlignment = StringAlignment.Near
                strFormat.Alignment = StringAlignment.Far
            Case ContentAlignment.BottomCenter
                strFormat.LineAlignment = StringAlignment.Far
                strFormat.Alignment = StringAlignment.Center
            Case ContentAlignment.BottomLeft
                strFormat.LineAlignment = StringAlignment.Far
                strFormat.Alignment = StringAlignment.Near
            Case ContentAlignment.BottomRight
                strFormat.LineAlignment = StringAlignment.Far
                strFormat.Alignment = StringAlignment.Far
        End Select
        Return strFormat
    End Function
#End Region

#Region "TCY̕`揈̉P"
    ' OnResizeCxgEventArgsp[^ێ
    Private resizeEeventArgs As EventArgs = Nothing

    'tH[̃TCYύX
    Protected Overrides Sub OnResize(ByVal e As System.EventArgs)
        ' TCYɃ{^̈ύX
        Me.Region = New Region(GetButtonRegionPath(0, 0))

        MyBase.OnResize(e)

        ' `揈̓AChԂɍs
        If resizeEeventArgs Is Nothing Then
            resizeEeventArgs = e

            ' fQ[gǉ
            AddHandler Application.Idle, AddressOf OnIdleInvalidate
        End If
    End Sub

    ' AvP[VAChԂ̂ƂɌĂяofQ[g
    Private Sub OnIdleInvalidate(ByVal s As Object, ByVal e As EventArgs)
        If Not resizeEeventArgs Is Nothing Then
            ' `揈s
            Invalidate()

            ' fQ[g폜
            resizeEeventArgs = Nothing
            RemoveHandler Application.Idle, AddressOf OnIdleInvalidate
        End If
    End Sub
#End Region

#Region "fUCi\p̓qNX"
    ' MenuButtonDesigner ̊Tv̐łBiqNXj
    Friend Class MenuButtonDesigner
        Inherits ControlDesigner
        Protected Overrides Sub PostFilterProperties(ByVal Properties As IDictionary)
            ' ̃vpeB̓fUCił͔\ɂ
            Properties.Remove("FlatStyle")
            Properties.Remove("BackgroundImage")
            Properties.Remove("Image")
            Properties.Remove("ImageAlign")
            Properties.Remove("ImageIndex")
            Properties.Remove("ImageList")
        End Sub
    End Class
#End Region

End Class
